<?php

namespace SM\Controller;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use SM\Service\CalendarioAgendamentoService;
use SM\Traits\TResponse;

class CalendarioAgendamentoController
{
    use TResponse;
    
    protected $CalendarioAgendamentoService;
    
    public function __construct(CalendarioAgendamentoService $CalendarioAgendamentoService)
    {
        $this->CalendarioAgendamentoService = $CalendarioAgendamentoService;
    }
    
    public function fct_apropagendamento_calendario()
    {
        try {
            $data = $this->CalendarioAgendamentoService->fct_apropagendamento_calendario();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function fct_apropagendamento_cal(Request $request)
    {
        try {
            $data = $this->CalendarioAgendamentoService->fct_apropagendamento_cal($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function fct_relacestruturacont_estruturam(Request $request)
    {
        try {
            $data = $this->CalendarioAgendamentoService->fct_relacestruturacont_estruturam($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function find_parceiro()
    {
        try {
            $data = $this->CalendarioAgendamentoService->find_parceiro();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function fct_view_recursos()
    {
        try {
            $data = $this->CalendarioAgendamentoService->fct_view_recursos();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function fct_contrato_grid()
    {
        try {
            $data = $this->CalendarioAgendamentoService->fct_contrato_grid();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

}