<?php

namespace SM\Factory;

use Doctrine\ORM\EntityManager;
use \Teknisa\Model\Traits\TQuery;

class CalendarioLembretesFactory
{
    use TQuery;

    protected $connection;

    protected $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    public function getCalendarioLembreteContrato($filtroPeriodoData, $filtroContrato, $filtroDescricao)
    {
        $sql = "SELECT
                    LEMBRETE.NRLEMBRETECONT,
                    LEMBRETE.NRSEQCONTRATO,
                    LEMBRETE.DSLEMBRETECONT,
                    LEMBRETE.DSEMAILLEMBRETE,
                    LEMBRETE.DTHRLEMBRETE,
                    TO_CHAR(LEMBRETE.DTHRLEMBRETE, 'HH24:MI')    AS HRLEMBRETE,
                    TO_CHAR(LEMBRETE.DTHRLEMBRETE, 'DD/MM/YYYY') AS DTLEMBRETE,
                    LEMBRETE.NRORG,
                    LEMBRETE.IDATIVO,
                    LEMBRETE.DTINCLUSAO,
                    LEMBRETE.CDOPERINCLUSAO,
                    LEMBRETE.NRORGINCLUSAO,
                    LEMBRETE.DTULTATU,
                    LEMBRETE.CDOPERULTATU,
                    LEMBRETE.NRORGULTATU,
                    (
                        SELECT
                            RTRIM(XMLAGG(XMLELEMENT(E, CDOPERADOR, ',').EXTRACT('//text()')
                                ORDER BY
                                    NROPERLEMBRETECONT
                            ).GETCLOBVAL(),
                                ',') AS NROPERLEMBRETECONT
                        FROM
                            FCT_OPERLEMBRETECONT
                        WHERE
                                NRLEMBRETECONT = LEMBRETE.NRLEMBRETECONT
                            AND NRORG = LEMBRETE.NRORG
                    )                                            AS PARTICIPANTES,
                    CONT.NRCONTRATOFCT,
                    PARC.NMSECUNDARIPARC,
                    CONT.NRCONTRATOFCT || ' | ' ||  PARC.NMSECUNDARIPARC AS DESCRICAOCONTRATO
                FROM
                    FCT_LEMBRETECONT LEMBRETE
                    INNER JOIN FCT_CONTRATO CONT ON LEMBRETE.NRSEQCONTRATO = CONT.NRSEQCONTRATO
                    INNER JOIN PARCNEGOCIO PARC ON CONT.NRPARCNEGOCIO = PARC.NRPARCNEGOCIO
                WHERE 
                    LEMBRETE.IDATIVO = 'S'
                    $filtroPeriodoData
                    $filtroContrato
                    $filtroDescricao";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }
}
